




NOT_ALLOWED_TERMINAL equ 3
STACK_OVERFLOW equ 4
RIGHT_PARENTHESIS_ERROR equ 8
LEFT_PARENTHESIS_ERROR equ 9

MAX_NUM equ 256

TRUE   equ 1
FALSE  equ 0

PLUS equ '+'
MINUS equ '-'
MULF equ '*'
DIVF equ '/'
LEER equ ' '



.data?
opStack db (MAX_NUM) dup (?)


.code
; Inputcheck
; Param: input: String in Infix Form
; Return: TRUE oder Fehlercode, in ESI Fehlerstelle (optionale Auswertung)
; Erlaubte Zeichen: +-+/.() Leerzeichen

checkInfixInput proc input:DWORD	
	
  mov esi,input
  dec esi
  xor eax,eax
  CHECK_LOOP:
    add esi,1
    mov al,byte ptr [esi]
    test al,al
    jz CHECK_OUT
      cmp al,' '
      je CHECK_LOOP
      cmp al,'('
        jb error
      cmp al,'/' 
        jg isdigit
      cmp al,','
        je error
        jmp CHECK_LOOP
      isdigit:
      cmp al,'9'
        jg error
      cmp al,'0'
        jb error
      
      jmp CHECK_LOOP
      error:
      mov eax,NOT_ALLOWED_TERMINAL
      ret
  CHECK_OUT:  
  mov eax,TRUE
  ret

checkInfixInput endp

; berfhrt Infix zu UPN
; Parameter: input: String in Infix Form, output: String in UPN Form,
; Return: TRUE oder Fehlercode, in ESI Fehlerstelle (optionale Auswertung)
; Achtung: der Aufrufer hat dafr zu sorgen, dass output gro genug ist!
infixToUPN proc input:DWORD, output:DWORD

  invoke checkInfixInput,input
  cmp eax,TRUE
  je @f
    ret
  @@:  
  invoke stackNew,addr opStack,MAX_NUM
  mov esi,input
  mov edi,output
  dec esi
  
  
  TRANS_LOOP:
  add esi,1
  
  
  mov bl,byte ptr [esi]
  test bl,bl
    je TRANS_OUT
      
  cmp bl,'0'
    jb isDot
  cmp bl,'9'
    jg @f
  ;ansonsten eine Ziffer  
  jmp COPY_TO_OUTPUT  
  isDot:
  cmp bl,'.'
  jne @f  
    COPY_TO_OUTPUT:
    mov byte ptr [edi],bl ;Ziffer/Punkt->kopiere zur Ausgabe
    add edi,1
    jmp TRANS_LOOP 
  @@:    
  ;ansonsten keine Ziffer->zahl zu ende, Leerzeichen einfgen
  mov byte ptr [edi],LEER
  add edi,1
  
  cmp bl,'('
  jne @f
    invoke stackIsFull,addr opStack
    cmp eax,TRUE
    jne no_err
      mov eax, STACK_OVERFLOW
      ret
    no_err: 
    invoke stackPush,addr opStack,bl
    jmp TRANS_LOOP
  @@:  
  cmp bl,')'
  jne @f
     POP_LOOP:
       invoke stackIsEmpty,addr opStack
       cmp eax,TRUE  ;Stack leer -> ) Klammer zu viel
       jne no_err2
         mov eax, RIGHT_PARENTHESIS_ERROR
         ret
       no_err2:
       invoke stackPop,addr opStack
       cmp al,'('
       je TRANS_LOOP
       mov byte ptr[edi],al
       add edi,1
       jmp POP_LOOP
  @@:
   ;hack um (-X) Zahlen zu akzeptieren    
    cmp bl,MINUS    
    jne no_neg
    cmp byte ptr[esi-1],'('
    jne no_neg
      mov word ptr [edi]," 0"
      add edi,2
    no_neg:
    
  TOP_LOOP:
  invoke stackIsEmpty,addr opStack
  cmp eax,TRUE
  jne @f
  PUSH_OP:
    invoke stackPush,addr opStack,bl
    jmp TRANS_LOOP
  @@:
  
  invoke stackTop,addr opStack
  cmp al,'('
  jne @f    
    invoke stackPush,addr opStack,bl
    jmp TRANS_LOOP
  @@:
  cmp bl,MINUS 
  je @f
  cmp bl,PLUS
  je @f
  HIGHER_PRIORITY_CHECK: ;weder plus noch minus, Prioritt feststellen
  cmp al, PLUS
  je PUSH_OP
  cmp al,MINUS
  je PUSH_OP
  @@:    
    invoke stackPop,addr opStack
    mov byte ptr[edi],al
    add edi,1
    jmp TOP_LOOP
  @@:     
  
  
  TRANS_OUT:  ;input leer, also alles runterpopen
 
    invoke stackIsEmpty,addr opStack
    cmp eax,TRUE
    je ENDE
      invoke stackPop,addr opStack
      cmp al,'('
      jne @f
        mov eax,LEFT_PARENTHESIS_ERROR
        ret
      @@:
      mov byte ptr [edi],al
      add edi,1
      jmp TRANS_OUT
    ENDE:
    mov byte ptr [edi],0
    mov eax,TRUE  

ret
infixToUPN endp